'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "26_Missing8x3FileNames.vbs"
ScriptFunction  = "Fix Errors due to missing 8x3 File names"

Set WshShell    = CreateObject("WScript.Shell")
Set Installer   = CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************

'We have to be sure that there is a File table within the MSI.
SQL         = 	"SELECT * FROM _Tables"
Set View    = 	DataBase.OpenView(SQL)
View.execute
Set record  = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "File" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
    'Cant possibly be any errors
  	Wscript.quit
end if

        SQL = 	"SELECT * FROM File"
        Set View = 	DataBase.OpenView(SQL)
        View.execute
        Set record = view.Fetch

        While Not (record Is Nothing)
          If Len(Record.Stringdata(3))  > 12 Then
            'We need to also check that short filename is present
            If instr(Record.Stringdata(3),"|") = 0 then
               'the only details are for a LFN system
                Record.Stringdata(3) =  ShortName(Record.Stringdata(3)) & "|" & Record.Stringdata(3) 
                
                View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
            
            end if

            
          end if
          
       

          Set record = view.Fetch
        Wend      

Database.Commit


Cleanup

'****************************************
'Functions
'****************************************

Function ShortName(LongFilename)
  'A short file name is simply the last four characters of the string (.EXT)
  'And the first 8.  All irrelevant with modern computing
  'msgbox "Incoming LFN = " & LongFilename
  
  If Len(LongFilename)  > 12 Then
    tempstring = Left(LongFilename,8) & Right(LongFilename,4)
    'msgbox "tempstring = " & tempstring
  else
    tempstring = LongFilename
  end if
   
  Shortname = tempstring
  
End Function

Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function