'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName        = "53_BitmapErrors.vbs"
ScriptFunction    = "Removes Bitmap errors for Dialogs"

Set WshShell      = CreateObject("WScript.Shell")
Set Installer     = CreateObject("WindowsInstaller.Installer")
Set objFSO        = CreateObject("Scripting.FileSystemObject")

Appdata           = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database      = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************

'We have to be sure that there is a Control table within the MSI.
SQL = 	"SELECT * FROM _Tables"
Set View = 	DataBase.OpenView(SQL)
View.execute
Set record = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "Control" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
    'Cant possibly be any errors
  	Wscript.quit
end if



'We need to select all entries in the control table that reference Bitmaps
'These entries need to be found in the Binary table or a blank bitmap should be added to prevent errors

SQL           = "SELECT * FROM Control"
Set View      = DataBase.OpenView(SQL)
View.execute

Set record = view.Fetch

' Recursively list the entries within the Table

BitmapCount=0
While Not (record Is Nothing)
  'BitmapCount = BitmapCount + 1
  If Ucase(Record.StringData(3)) = "BITMAP" then 'type field - we want Bitmaps
    BitmapCount=BitmapCount+1
  end if
  Set record = view.Fetch  
Wend

BitmapCount=BitmapCount-1
'msgbox "declaring array size " &BitmapCount

redim BitmapArray(BitmapCount,2)

'We can now populate the array
BitmapCount=0

Set record = view.Fetch
While Not (record Is Nothing)
  If Ucase(Record.StringData(3)) = "BITMAP" then 'type field - we want Bitmaps
    BitmapArray(BitmapCount,1)= Record.StringData(10) 'Bitmap name for Binary Table  
    
    'Account for poorly used IS templates where bitmaps aren't given a name
    if len(Record.StringData(10)) = 0 then 'calls a bitmap with no name
        Record.StringData(10) ="BlankBitmap"
        'BitmapArray(x,1) = "BlankBitmap"
        View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        BlankBitmap=1
    end if        
    BitmapCount=BitmapCount+1
  end if
    Set record = view.Fetch
Wend

        View.Close
        Database.Commit


'At this point we have an array with the names of all Bitmaps that should
'Exist within the Binary table - any that are missing will cause MSI errors
' Recursively list the entries within the Table

SQL           = "SELECT * FROM Binary"
Set View      = DataBase.OpenView(SQL)
View.execute

Set record    = view.Fetch

for X =0 to ubound(BitmapArray) 'recurse through our Bitmap entry array
  'msgbox "bitmap searched for =" &BitmapArray(x,1)
  BitmapFound=0 'Reset our Bitmap counter
  
  Set View = DataBase.OpenView("SELECT * FROM Binary WHERE Name = '" &BitmapArray(x,1) &"'")
  View.Execute
  Set Record = View.Fetch 'The record will be nothing if the binary doesnt exist
  If Record Is Nothing Then 
    BitmapArray(x,2) = 1 
  end if  
next

'The array will have a list of bitmaps that need to be added
'We have to be careful because a single bitmap may be used by multiple controls
'so we must check for it's existence each time we try to add it

for X=0 to ubound(BitmapArray) 

Set View = DataBase.OpenView("SELECT * FROM Binary WHERE Name = '" &BitmapArray(x,1) &"'")
View.Execute
Set Record = View.Fetch

'msgbox BitmapArray(x,1) 



If Record Is Nothing and len(BitmapArray(x,1)) > 0 Then 
  Set Record = Installer.CreateRecord(1)
  Record.SetStream 1, objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources\BlankBitmap.bmp"  
  Set View = Database.OpenView("INSERT INTO `Binary` (`Name`, `Data`) VALUES ('" &BitmapArray(x,1) &"', ?)")
  View.Execute Record
else
  'Do nothing
end if
  
next

If BlankBitmap=1 then
  Record.SetStream 1, objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources\BlankBitmap.bmp"  
  Set View = Database.OpenView("INSERT INTO `Binary` (`Name`, `Data`) VALUES ('BlankBitmap', ?)")
  View.Execute Record
end if


Database.Commit


Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
Set Database = Nothing
End Function